Index: /NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_ecmwf.F90
===================================================================
--- /NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 11962)
+++ /NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 11963)
@@ -2,21 +2,31 @@
    !!======================================================================
    !!                   ***  MODULE  sbcblk_skin_ecmwf  ***
-   !! Computes:
-   !!   * the surface skin temperature (aka SSST) based on the cool-skin/warm-layer
-   !!     scheme used at ECMWF
-   !!    Using formulation/param. of IFS of ECMWF (cycle 40r1)
-   !!   based on IFS doc (avaible online on the ECMWF's website)
-   !!
-   !!   From routine turb_ecmwf maintained and developed in AeroBulk
-   !!            (https://github.com/brodeau/aerobulk)
-   !!
-   !! ** Author: L. Brodeau, September 2019 / AeroBulk (https://github.com/brodeau/aerobulk)
+   !!
+   !!   Module that gathers the cool-skin and warm-layer parameterization used
+   !!   by the IFS at ECMWF (recoded from scratch =>
+   !!   https://github.com/brodeau/aerobulk)
+   !!
+   !!  Mainly based on Zeng & Beljaars, 2005 with the more recent add-up from
+   !!  Takaya et al., 2010 when it comes to the warm-layer parameterization
+   !!  (contribution of extra mixing due to Langmuir circulation)
+   !!
+   !!  - Zeng X., and A. Beljaars, 2005: A prognostic scheme of sea surface skin
+   !!    temperature for modeling and data assimilation. Geophysical Research
+   !!    Letters, 32 (14) , pp. 1-4.
+   !!
+   !!  - Takaya, Y., J.-R. Bildot, A. C. M. Beljaars, and P. A. E. M. Janssen,
+   !!    2010: Refinements to a prognostic scheme of skin sea surface
+   !!    temperature. J. Geophys. Res., 115, C06009, doi:10.1029/2009JC005985
+   !!
+   !!   Most of the formula are taken from the documentation of IFS of ECMWF
+   !!            (cycle 40r1) (avaible online on the ECMWF's website)
+   !!
+   !!   Routine 'sbcblk_skin_ecmwf' also maintained and developed in AeroBulk (as
+   !!            'mod_skin_ecmwf')
+   !!    (https://github.com/brodeau/aerobulk)
+   !!
+   !! ** Author: L. Brodeau, November 2019 / AeroBulk (https://github.com/brodeau/aerobulk)
    !!----------------------------------------------------------------------
-   !! History :  4.0  !  2016-02  (L.Brodeau)   Original code
-   !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!  cswl_ecmwf : computes the surface skin temperature (aka SSST)
-   !!               based on the cool-skin/warm-layer scheme used at ECMWF
+   !! History :  4.x  !  2019-11  (L.Brodeau)   Original code
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
@@ -25,5 +35,5 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
 
-   USE sbcblk_phy      !LOLO: all thermodynamics functions, rho_air, q_sat, etc...
+   USE sbcblk_phy      ! misc. functions for marine ABL physics (rho_air, q_sat, bulk_formula, etc)
 
    USE lib_mpp         ! distribued memory computing library
@@ -31,5 +41,4 @@
    USE lib_fortran     ! to use key_nosignedzero
 
-
    IMPLICIT NONE
    PRIVATE
@@ -38,11 +47,13 @@
 
    !! Cool-skin related parameters:
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: &
-      &                        dT_cs         !: dT due to cool-skin effect => temperature difference between air-sea interface (z=0) and right below viscous layer (z=delta)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: dT_cs !: dT due to cool-skin effect
+   !                                                      ! => temperature difference between air-sea interface (z=0)
+   !                                                      !    and right below viscous layer (z=delta)
 
    !! Warm-layer related parameters:
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: &
-      &                        dT_wl,  &   !: dT due to warm-layer effect => difference between "almost surface (right below viscous layer, z=delta) and depth of bulk SST (z=gdept_1d(1))
-      &                        Hz_wl       !: depth of warm-layer [m]
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: dT_wl !: dT due to warm-layer effect
+   !                                                      ! => difference between "almost surface (right below
+   !                                                      !    viscous layer, z=delta) and depth of bulk SST (z=gdept_1d(1))
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: Hz_wl !: depth (aka thickness) of warm-layer [m]
    !
    REAL(wp), PARAMETER, PUBLIC :: rd0  = 3.    !: Depth scale [m] of warm layer, "d" in Eq.11 (Zeng & Beljaars 2005)
@@ -62,8 +73,7 @@
       !! Cool-skin parameterization, based on Fairall et al., 1996:
       !!
-      !! Fairall, C. W., Bradley, E. F., Godfrey, J. S., Wick, G. A.,
-      !! Edson, J. B., and Young, G. S. ( 1996), Cool‐skin and warm‐layer
-      !! effects on sea surface temperature, J. Geophys. Res., 101( C1), 1295-1308,
-      !! doi:10.1029/95JC03190.
+      !!  - Zeng X., and A. Beljaars, 2005: A prognostic scheme of sea surface
+      !!    skin temperature for modeling and data assimilation. Geophysical
+      !!    Research Letters, 32 (14) , pp. 1-4.
       !!
       !!------------------------------------------------------------------
@@ -81,5 +91,5 @@
       !!---------------------------------------------------------------------
       INTEGER  :: ji, jj, jc
-      REAL(wp) :: zQabs, zdelta, zfr
+      REAL(wp) :: zQabs, zdlt, zfr, zalfa, zus
       !!---------------------------------------------------------------------
       DO jj = 1, jpj
@@ -87,16 +97,21 @@
 
             zQabs = pQnsol(ji,jj) ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
-            !                     !   => we DO not miss a lot assuming 0 solar flux absorbed in the tiny layer of thicknes zdelta...
-
-            zdelta = delta_skin_layer( alpha_sw(pSST(ji,jj)), zQabs, pustar(ji,jj) )
-
-            DO jc = 1, 4 ! because implicit in terms of zdelta...
-               zfr = MAX( 0.065_wp + 11._wp*zdelta - 6.6E-5_wp/zdelta*(1._wp - EXP(-zdelta/8.E-4_wp)) , 0.01_wp ) ! Solar absorption, Eq.(5) Zeng & Beljaars, 2005
-               !              =>  (WARNING: 0.065 rather than 0.137 in Fairal et al. 1996)
+            !                     !   => we DO not miss a lot assuming 0 solar flux absorbed in the tiny layer of thicknes zdlt...
+
+            zalfa = alpha_sw(pSST(ji,jj)) ! (crude) thermal expansion coefficient of sea-water [1/K]
+            zus   = pustar(ji,jj)
+
+            zdlt = delta_skin_layer( zalfa, zQabs, zus )
+
+            DO jc = 1, 4 ! because implicit in terms of zdlt...
+               zfr = MAX( 0.065_wp + 11._wp*zdlt  &
+                  &       - 6.6E-5_wp/zdlt*(1._wp - EXP(-zdlt/8.E-4_wp)) &
+                  &      , 0.01_wp ) ! Solar absorption, Eq.(5) Zeng & Beljaars, 2005
+               !                     !  =>  (WARNING: 0.065 rather than 0.137 in Fairal et al. 1996)
                zQabs = pQnsol(ji,jj) + zfr*pQsw(ji,jj)
-               zdelta = delta_skin_layer( alpha_sw(pSST(ji,jj)), zQabs, pustar(ji,jj) )
+               zdlt = delta_skin_layer( zalfa, zQabs, zus )
             END DO
 
-            dT_cs(ji,jj) = zQabs*zdelta/rk0_w   ! temperature increment, yes dT_cs can actually > 0, if Qabs > 0 (rare but possible!)
+            dT_cs(ji,jj) = zQabs*zdlt/rk0_w   ! temperature increment, yes dT_cs can actually > 0, if Qabs > 0 (rare but possible!)
 
          END DO
@@ -106,14 +121,22 @@
 
 
-
    SUBROUTINE WL_ECMWF( pQsw, pQnsol, pustar, pSST,  pustk )
       !!---------------------------------------------------------------------
       !!
-      !!  Warm-Layer scheme according to Zeng & Beljaars, 2005 (GRL)
-      !!  " A prognostic scheme of sea surface skin temperature for modeling and data assimilation "
+      !!  Warm-Layer scheme according to Zeng & Beljaars, 2005 (GRL) with the
+      !!  more recent add-up from Takaya et al., 2010 when it comes to the
+      !!  warm-layer parameterization (contribution of extra mixing due to
+      !!  Langmuir circulation)
+      !!
+      !!  - Zeng X., and A. Beljaars, 2005: A prognostic scheme of sea surface skin
+      !!    temperature for modeling and data assimilation. Geophysical Research
+      !!    Letters, 32 (14) , pp. 1-4.
+      !!
+      !!  - Takaya, Y., J.-R. Bildot, A. C. M. Beljaars, and P. A. E. M. Janssen,
+      !!    2010: Refinements to a prognostic scheme of skin sea surface
+      !!    temperature. J. Geophys. Res., 115, C06009, doi:10.1029/2009JC005985
       !!
       !!  STIL NO PROGNOSTIC EQUATION FOR THE DEPTH OF THE WARM-LAYER!
       !!
-      !!    As included in IFS Cy45r1   /  E.C.M.W.F.
       !!     ------------------------------------------------------------------
       !!
@@ -133,15 +156,14 @@
       INTEGER :: ji, jj, jc
       !
-      REAL(wp) :: &
-         & zHwl,    &  !: thickness of the warm-layer [m]
-         & ztcorr,  &  !: correction of dT w.r.t measurement depth of bulk SST (first T-point)
-         & zalpha, & !: thermal expansion coefficient of sea-water [1/K]
-         & zdTwl_b, zdTwl_n, & ! temp. diff. between "almost surface (right below viscous layer) and bottom of WL
-         & zfr, zeta, &
-         & zusw, zusw2, &
-         & zLa, zfLa, &
-         & flg, zwf, zQabs, &
-         & ZA, ZB, zL1, zL2, &
-         &  zcst0, zcst1, zcst2, zcst3
+      REAL(wp) :: zHwl      !: thickness of the warm-layer [m]
+      REAL(wp) :: ztcorr    !: correction of dT w.r.t measurement depth of bulk SST (first T-point)
+      REAL(wp) :: zalfa     !: thermal expansion coefficient of sea-water [1/K]
+      REAL(wp) :: zdTwl_b, zdTwl_n  !: temp. diff. between "almost surface (right below viscous layer) and bottom of WL
+      REAL(wp) :: zfr, zeta 
+      REAL(wp) :: zusw, zusw2 
+      REAL(wp) :: zLa, zfLa 
+      REAL(wp) :: flg, zwf, zQabs 
+      REAL(wp) :: ZA, ZB, zL1, zL2
+      REAL(wp) :: zcst0, zcst1, zcst2, zcst3
       !
       LOGICAL :: l_pustk_known
@@ -149,5 +171,5 @@
 
       l_pustk_known = .FALSE.
-      IF ( PRESENT(pustk) ) l_pustk_known = .TRUE.
+      IF( PRESENT(pustk) ) l_pustk_known = .TRUE.
 
       DO jj = 1, jpj
@@ -158,5 +180,5 @@
 
             !! Previous value of dT / warm-layer, adapted to depth:
-            flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zHwl )               ! => 1 when gdept_1d(1)>zHwl (dT_wl(ji,jj) = zdTwl) | 0 when z_s$
+            flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zHwl ) ! => 1 when gdept_1d(1)>zHwl (dT_wl(ji,jj) = zdTwl) | 0 when z_s$
             ztcorr = flg + (1._wp - flg)*gdept_1d(1)/zHwl
             zdTwl_b = MAX ( dT_wl(ji,jj) / ztcorr , 0._wp )
@@ -166,6 +188,5 @@
             !! => so here since pdT is difference between surface and gdept_1d(1), need to increase fof zdTwl !
 
-            zalpha = alpha_sw( pSST(ji,jj) ) ! thermal expansion coefficient of sea-water (SST accurate enough!)
-
+            zalfa = alpha_sw( pSST(ji,jj) ) ! (crude) thermal expansion coefficient of sea-water [1/K] (SST accurate enough!)
 
             ! *** zfr = Fraction of solar radiation absorbed in warm layer (-)
@@ -178,22 +199,22 @@
 
             ! Langmuir:
-            IF ( l_pustk_known ) THEN
+            IF( l_pustk_known ) THEN
                zLa = SQRT(zusw/MAX(pustk(ji,jj),1.E-6))
             ELSE
                zla = 0.3_wp
-            END IF
+            ENDIF
             zfLa = MAX( zla**(-2._wp/3._wp) , 1._wp )   ! Eq.(6)
 
             zwf = 0.5_wp + SIGN(0.5_wp, zQabs)  ! zQabs > 0. => 1.  / zQabs < 0. => 0.
 
-            zcst1 = vkarmn*grav*zalpha
+            zcst1 = vkarmn*grav*zalfa
 
             ! 1/L when zQabs > 0 :
             zL2 = zcst1*zQabs / (zRhoCp_w*zusw2*zusw)
-               
+
             zcst2 = zcst1 / ( 5._wp*zHwl*zusw2 )  !OR: zcst2 = zcst1*rNuwl0 / ( 5._wp*zHwl*zusw2 ) ???
 
             zcst0 = rdt * (rNuwl0 + 1._wp) / zHwl
-            
+
             ZA = zcst0 * zQabs / ( rNuwl0 * zRhoCp_w )
 
@@ -203,5 +224,5 @@
             !! the sake of optimizations... So all these operations are not done
             !! over and over within the iteration loop...
-            
+
             !! T R U L L Y   I M P L I C I T => needs itteration
             !! => have to itterate just because the 1/(Monin-Obukhov length), zL1, uses zdTwl when zQabs < 0..
@@ -209,11 +230,10 @@
             zdTwl_n = zdTwl_b
             DO jc = 1, 10
-               
+
                zdTwl_n = 0.5_wp * ( zdTwl_n + zdTwl_b ) ! semi implicit, for faster convergence
-               
+
                ! 1/L when zdTwl > 0 .AND. zQabs < 0 :
-               zL1 =         SQRT( zdTwl_n * zcst2 ) ! / zusw !!! Or??? => vkarmn * SQRT( zdTwl_n*grav*zalpha/( 5._wp*zHwl ) ) / zusw
-               !zL1 = vkarmn*SQRT( zdTwl_n       *grav*zalpha        / ( 5._wp*zHwl ) ) / zusw   ! => vkarmn outside, not inside zcst1 (just for this particular line) ???
-               
+               zL1 =         SQRT( zdTwl_n * zcst2 ) ! / zusw !!! Or??? => vkarmn * SQRT( zdTwl_n*grav*zalfa/( 5._wp*zHwl ) ) / zusw
+
                ! Stability parameter (z/L):
                zeta =  (1._wp - zwf) * zHwl*zL1   +   zwf * zHwl*zL2
@@ -224,13 +244,12 @@
 
             END DO
-            
+
             !! Update:
             dT_wl(ji,jj) = zdTwl_n * ztcorr
-            
+
          END DO
       END DO
 
    END SUBROUTINE WL_ECMWF
-
 
 
@@ -249,5 +268,6 @@
       REAL(wp)                :: delta_skin_layer
       REAL(wp), INTENT(in)    :: palpha   ! thermal expansion coefficient of sea-water (SST accurate enough!)
-      REAL(wp), INTENT(in)    :: pQd    ! < 0 !!! part of the net heat flux actually absorbed in the WL [W/m^2] => term "Q + Rs*fs" in eq.6 of Fairall et al. 1996
+      REAL(wp), INTENT(in)    :: pQd ! < 0 !!! part of the net heat flux actually absorbed in the WL [W/m^2]
+      !                              !  => term "Q + Rs*fs" in eq.6 of Fairall et al. 1996
       REAL(wp), INTENT(in)    :: pustar_a ! friction velocity in the air (u*) [m/s]
       !!---------------------------------------------------------------------
@@ -255,6 +275,6 @@
       !!---------------------------------------------------------------------
       ztf = 0.5_wp + SIGN(0.5_wp, pQd)  ! Qabs < 0 => cooling of the viscous layer => ztf = 0 (regular case)
-      !                                 ! Qabs > 0 => warming of the viscous layer => ztf = 1 (ex: weak evaporation and strong positive sensible heat flux)
-      !
+      !                                 ! Qabs > 0 => warming of the viscous layer => ztf = 1
+      !                                 !    (ex: weak evaporation and strong positive sensible heat flux)
       zusw  = MAX(pustar_a, 1.E-4_wp) * sq_radrw    ! u* in the water
       zusw2 = zusw*zusw
@@ -281,12 +301,9 @@
       REAL(wp) :: ztf, zzt2
       !!---------------------------------------------------------------------
-      !
       zzt2 = pzeta*pzeta
-      !
       ztf = 0.5_wp + SIGN(0.5_wp, pzeta)  ! zeta > 0 => ztf = 1
       !                                   ! zeta < 0 => ztf = 0
       PHI =      ztf     * ( 1. + (5.*pzeta + 4.*zzt2)/(1. + 3.*pzeta + 0.25*zzt2) ) &   ! zeta > 0
          &  + (1. - ztf) * 1./SQRT( 1. - 16.*(-ABS(pzeta)) )                             ! zeta < 0
-      !
    END FUNCTION PHI
 
